﻿using System.Collections;
using System.Collections.Generic;
using TMPro;
using UnityEngine;
using UnityEngine.Networking;

public class CategoryButton : GazeButton
{
    private string textureUrl;
    private string categoryName;
    private string categoryId;

    //Referenz zum CategoryReader
    private GameObject categoryReader;

    private string filterProductsURL;


    private GameObject ProductSelector;
    public GameObject preProductSelector;


    public override void Start()
    {
        //Ausführen der Start Methode in der Basis Klasse
        base.Start();

        // Suchen des Child Objects, welches den Text enthält und setzen des Textes
        this.transform.Find("CatName").GetComponent<TextMeshPro>().text = categoryName;

        //  Asynchrones Laden des Kategoriebildes
        StartCoroutine ("DownloadImage");

    }


    public override void Update()
    {
        //Ausführen der Update Methode in der Basis Klasse
        base.Update();
    }

    public override void gazeTimeElapsed()
    {
        ProductSelector = Instantiate(preProductSelector, this.transform.position, transform.rotation);
        ProductSelector.GetComponent<ProductReader>().setFilterUrl(filterProductsURL);  
        categoryReader.GetComponent<CategoryReader>().DestroyCategories();
    }

    IEnumerator DownloadImage()
    {
        UnityWebRequest request = UnityWebRequestTexture.GetTexture(textureUrl);
        yield return request.SendWebRequest();

        if (request.isNetworkError || request.isHttpError)
        {
            Debug.Log(request.error);
        }
        yield return DownloadHandlerTexture.GetContent(request);
        //in der Komponente "MeshRenderer" das Attribut "mainTexture" setzen
        this.GetComponent<MeshRenderer>().material.mainTexture = DownloadHandlerTexture.GetContent(request);
    }

    //diese Methode wird vom Category Reader aufgerufen um dem Button seine Attribute zu übermitteln
    public void setAttributes(string id, string name, string url, GameObject loader)
    {

        textureUrl = url;
        categoryName = name;
        categoryId = id;
        categoryReader = loader;
        filterProductsURL = " " + categoryId;

    }



}
